# -*- coding: iso-8859-15 -*-

##########################
# TP 3 : Listes Chaines #
##########################

# Une liste chane est constitu de Noeud. Chaque noeud est
# caractris par une valeur 'val 'ainsi qu'un pointeur 'suiv'
# vers le noeud suivant. Le pointeur 'suiv' du dernier noeud
# de la liste est gale  'None'. Une liste chine est alors
# caractrise par un pointeur vers son premier Noeud.

class Noeud:
    def __init__(self,val,suiv=None):
        #Par dfaut le pointeur 'suiv' vaut 'None'
        self.val=val # Valeur du noeud
        self.suiv=suiv # Pointeur vers le noeud suivant

class Liste:
    def __init__(self,premier=None):
        # Par defaut la liste est vide 
        self.premier=premier
        
#***********************************
# Voici quelques exemples de liste *
#***********************************

# 1. La liste vide
listeVide=Liste()

# 2. La liste rduite  l'lment 5
listeSingleton=Liste(Noeud(5))

# 3. La liste 2,5,8,3,2,4
liste=Liste(Noeud(2,Noeud(5,Noeud(8,Noeud(3,Noeud(2,Noeud(4)))))))

#*************
# Exercice 1 *
#*************

# Ecrire une fonction affiche_liste(Liste) affichant une liste chine
# Exemple :
#  >>> affiche_liste(listeVide) -> ( )
#  >>> affiche_liste(listeSingleton) -> ( 5 )
#  >>> affiche_liste(liste) -> ( 2 5 8 3 2 4 )

# Pour demander  la commande print de ne faire de retour  la ligne
# on peut utiliser print(str,end="").

def affiche_liste(l):
    print("(",end="")
    courant=l.premier
    while courant!=None:
        print(" ",end="")
        print(courant.val,end="")
        courant=courant.suiv
    print(" )")

#**************
#* Exercice 2 *
#**************

# Ecrire les fonctions suivantes.

# 1. est_vide(l) qui teste si la liste l est vide.

def est_vide(l):
    return l.premier==None

# 2. taille(l) qui retourne le nombre d'lments de la liste l.

def taille(l):
    n=0
    courant=l.premier
    while courant!=None:
        n=n+1
        courant=courant.suiv
    return n
        
# 3. inserer_debut(l,v) qui insre v au dbut de la liste l.

def inserer_debut(l,v):
    n=Noeud(v,l.premier)
    l.premier=n
    
# 4. nombre(l,v) qui retourne le nombre d'occurences de la valeur v
# dans la liste l.

def nombre(l,v):
    n=0
    courant=l.premier
    while courant!=None:
        if courant.val==v:
            n=n+1
        courant=courant.suiv
    return n

# 5. remplace(l,v,w) qui remplace la valeur v par la valeur w dans la liste l.

def remplace(l,v,w):
    courant=l.premier
    while courant!=None:
        if courant.val==v:
            courant.val=w
        courant=courant.suiv
    
#**************
#* Exercice 3 *
#**************

# Ecrire les fonctions suivantes

# 1. inserer_fin(l,v) qui insere la valeur v  la fin de la liste l.

def inserer_fin(l,v):
    n=Noeud(v)
    if l.premier==None:
        l.premier=n
    else:
        courant=l.premier
        while courant.suiv!=None:
            courant=courant.suiv
        courant.suiv=n

# 2. recherche(l,v) qui retourne true si l'lment v est prsent dans
#    la liste l est false sinon.

def recherche(l,v):
    courant=l.premier
    while courant!=None:
        if courant.val==v:
            return True
        courant=courant.suiv
    return False

# 3. supprime(l,n) qui supprime le noeud numro n de la liste l. Le premier
#    noeud porte le numro 0.

def supprime(l,n):
    courant=l.premier
    if courant!=None:
        if n==0:
            l.premier=courant.suiv
        i=0
        while courant!=None and i<n:
            courant=courant.suiv
            i=i+1
        if courant!=None:
            if courant.suiv!=None:
                courant.suiv=courant.courant.suiv
            
# 4. supprime(l,v) qui supprime la valeur v de la liste l. La fonction
#    retournera le nombre de valeur supprimes.

def supprime2(l,v):
    precedent=None
    courant=l.premier
    while courant!=None:
        if courant.val==v:
            if precedent==None:
                l.premier=courant.suiv
            else:
                precedent.suiv=courant.suiv
        else:
            precedent=courant
        courant=courant.suiv
    
# 5. insere_apres(l,v,w) qui insere un noeud portant la valeur w apres la
#    premiere occurence de la valeur v dans la liste l. Ne fait rien si
#    v n'est pas prsent dans l.

# 6. insere_avant(l,v,w) qui insere un noeud portant la valeur w avant la
#    premiere occurence de la valeur v dans la liste l. Ne fait rien si
#    v n'est pas prsent dans l.

#**************
#* Exercice 4 *
#**************

# Ecrire une fonction inverse(l) qui retourne une liste obtenue en inversant
# la liste l

#**************
#* Exercice 5 *
#**************

# Refaire en python l'exercice de simulation de train du TD 3.


if __name__=="__main__":
    affiche_liste(listeVide)
    affiche_liste(listeSingleton)
    affiche_liste(liste)
    print(taille(listeVide))
    print(taille(listeSingleton))
    print(taille(liste))
    inserer_debut(liste,0)
    affiche_liste(liste)
    print(nombre(liste,2))
    remplace(liste,2,-1)
    affiche_liste(liste)
    inserer_fin(liste,-2)
    affiche_liste(liste)
    supprime2(liste,-1)
    affiche_liste(liste)
    supprime2(liste,0)
    affiche_liste(liste)
    supprime2(liste,-2)
    affiche_liste(liste)
    supprime2(listeVide,5)
    affiche_liste(listeVide)
